//::///////////////////////////////////////////////
//:: Summon Familiar
//:: NW_S2_Familiar
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
	This spell summons an Arcane casters familiar
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Sept 27, 2001
//:://////////////////////////////////////////////
// - NWN1 Style Familiars Pack - Added Reeron's spell resistance fix for familiars


// Applies non-bugged Spell Resistance.
void ApplyFamiliarSr(object oAssoc);
// Gets the Spell Resistance of oAssoc's skin.
int GetSkinSr(object oAssoc);


// ___________
// ** MAIN ***
// -----------
void main()
{
	//Yep thats it
	SummonFamiliar();

	object oAssoc = GetAssociate(ASSOCIATE_TYPE_FAMILIAR);
	DelayCommand(0.f, ApplyFamiliarSr(oAssoc));
}


// Applies non-bugged Spell Resistance.
void ApplyFamiliarSr(object oAssoc)
{
	int iSR = GetSkinSr(oAssoc);

	if (iSR != 0)
	{
		effect eSR	= EffectSpellResistanceIncrease(iSR);
		eSR			= SupernaturalEffect(eSR);
//		eSR			= SetEffectSpellId(eSR, -1000);	// This makes it compatible with Kaedrin's feats that handle SR.
													// But I don't believe it's applicable to associates.
		ApplyEffectToObject(DURATION_TYPE_PERMANENT, eSR, oAssoc);
	}
}


// Gets the Spell Resistance of oAssoc's skin.
int GetSkinSr(object oAssoc)
{
	object oSkin = GetItemInSlot(INVENTORY_SLOT_CARMOUR, oAssoc);
	if (GetIsObjectValid(oSkin))
	{
		itemproperty ipProp = GetFirstItemProperty(oSkin);
		while (GetIsItemPropertyValid(ipProp))
		{
			if (GetItemPropertyCostTable(ipProp) == 11) // spell resistance
			{
				int iCost = GetItemPropertyCostTableValue(ipProp);
				return StringToInt(Get2DAString("iprp_srcost", "Value", iCost));
			}
			ipProp = GetNextItemProperty(oSkin);
		}
	}

	return 0;
}